checkRequire("Lua_ObtainItemTipsWindow");
Lua_GashaponShowRewardWindow = class("Lua_GashaponShowRewardWindow", Lua_ObtainItemTipsWindow);
function Lua_GashaponShowRewardWindow:ctor()
	self:superCall("ctor");
	self.windowName = "Lua_GashaponShowRewardWindow";
end

function Lua_GashaponShowRewardWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.sureBtn = UICreate.createButton(self.content, LanUtil.getValue(765006), -170, -225, 220, 67);
	self.sureBtn.name = "sureBtn";
	self.sureBtn:setStyle(16);
	self.againBtn = UICreate.createButton(self.content, "", 170, -225, 220, 67);
	self.againBtn.name = "againBtn";

	self.moreCostTxt = UICreate.createLabel(self.content, nil, 170, -277, 0, 22, 22);
	self.moreCostTxt.name = "moreCostTxt";
	self.moreCostTxt.alignmentValue = 4;
	self.moreCostTxt.horizontalOverflowValue = 1;
	self.moreCostTxt.verticalOverflowValue = 1;

	self.sureBtn:addClickFuntion(self, self.hide);
	self.againBtn:addClickFuntion(self, self.onAgainBtnClick);
end

function Lua_GashaponShowRewardWindow:showWin(param)
	self:superCall("showWin", param);
	self.againBtn.label = LanUtil.formateStr(765007, param:getSize());
	self:updateCostInfo();
end

function Lua_GashaponShowRewardWindow:updateCostInfo()
	local drawType, itemInfo;
	if self.showData:getSize() == 1 then
		drawType, itemInfo = DataCenter.gashaponData:getOneDrawInfo();
	else
		drawType, itemInfo = DataCenter.gashaponData:getMoreDrawInfo();
	end
	local tvo = Lua_ToolVo.createToolVo(itemInfo[1], itemInfo[2]);
	local str = spliceIconStr(tvo.iconAtlas, tvo.iconSprite, tvo.iconWidth * 0.8, tvo.iconHeight * 0.8);
	local hasCount = DataCenter.packData:getItemCountById(itemInfo[1]);
	local isDrawCond = itemInfo[2] <= hasCount;
	local colorStr = isDrawCond and "FFFFFF" or "ED4C30";
	self.moreCostTxt.text = LanUtil.formateStr(765008, str, colorStr, hasCount, itemInfo[2]);
end

function Lua_GashaponShowRewardWindow:onTweenCompleted()
	if self.rewardEff then
		self.rewardEff:dispose();
		self.rewardEff = nil;
	end
	self.isClickClose = true;
	self:createCloseTips(0, -391, 0);
	DataCenter.packUtil:openHeroWindow(self.showHeroArr);
end

function Lua_GashaponShowRewardWindow:onAgainBtnClick()
	if self.showData:getSize() == 1 then
		Lua_MsgUtil.callFunc("ON_GASHAPON_AGAIN_DRAWONE");
	else
		Lua_MsgUtil.callFunc("ON_GASHAPON_AGAIN_DRAWMORE");
	end
	self:hide();
end

function Lua_GashaponShowRewardWindow:hide()
	self:superCall("hide");
	Lua_MsgUtil.callFunc("ON_GASHAPON_SHOW_MOVEEFF");
end

function Lua_GashaponShowRewardWindow:dispose()
	if self.sureBtn ~= nil then
		self.sureBtn:dispose();
		self.sureBtn = nil;
	end
	if self.againBtn ~= nil then
		self.againBtn:dispose();
		self.againBtn = nil;
	end
	if self.moreCostTxt ~= nil then
		self.moreCostTxt:dispose();
		self.moreCostTxt = nil;
	end
	self:superCall("dispose");
end