-- 自选礼包
Lua_GiftSelectionWindow = class("Lua_GiftSelectionWindow", Lua_Window);
function Lua_GiftSelectionWindow:ctor()
	self:superCall("ctor");

	self.layer = Lua_MainWinDefine.TIPS_WINDOW_LAYER;
	self.windowName = "Lua_GiftSelectionWindow";
	self.skinName = "GiftSelectionWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_GiftSelectionWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.selectedList = Array();
	self:addLuaEvent("GIFT_ITEM_SELECT", self, self.onGiftItemSelect);

	self.itemList = Lua_DragList.new(self.content, 580, 322, Lua_AxisDefine.Vertical);
	self.itemList:setLocation(0, 52);
	self.itemList.customParam = self.selectedList;
	self.itemList:setListCell(Lua_GiftSelectionItem, 100, 139, 5);
	self.itemList:setCellSpacing(20, 5);

    self.btnCancel:addClickFuntion(self, self.onBtnCancelClick);
    self.btnSure:addClickFuntion(self, self.onBtnSureClick);
end

function Lua_GiftSelectionWindow:dispose()
	if self.itemList ~= nil then
		self.itemList:dispose();
		self.itemList = nil;
	end
	self.selectedList = nil;
	self:superCall("dispose");
end

function Lua_GiftSelectionWindow:showWin(param)
	self:superCall("showWin", param);
	if param == nil or param.data == nil or param.data.client_goods_list == nil then
		self:hide();
		return;
	end

	self.desText.text = LanUtil.formateStr(309034, tostring(param.data.option_amount));
	local list = param.data.client_goods_list;
	local config = getConfig("option_gift");
	local arr = Array();
	local id;
	local tvo;
	local heroId;
	local openState;
	for i = 1, #list do
		id = list[i];
		tvo = Lua_ToolVo.createToolVo(config[id].item_id, config[id].item_amount);

		if tvo.isHeroChip then
			heroId = tvo.compound[1];
		elseif tvo.isIntactHero then
			heroId = tvo.hero_id;
		else
			heroId = nil;
			openState = nil;
		end
		if heroId ~= nil then
			openState = DataCenter.heroUtil:getNewHeroFuncOpenState(heroId, Lua_NewHeroFuncOpen.item);
		end
		if openState == nil or openState == true then
			arr:add({ optionId = id, tvo = tvo });
		end
	end
	self.itemList:setArrayData(arr);
end

function Lua_GiftSelectionWindow:onGiftItemSelect(optionId)
	local count = self.showData.data.option_amount;
	if count == 1 then
		self.selectedList:clear();
	end
	local index = self.selectedList:indexOf(optionId);
	if index == -1 then
		if self.selectedList:getSize() >= count then
			OperateAlert.show(LanUtil.formateStr(309035, tostring(self.showData.data.option_amount)));
			return;
		end
		self.selectedList:add(optionId);
	else
		self.selectedList:remove(index);
	end

	local showList = self.itemList.showList;
	for i = 1, showList:getSize() do
		showList[i]:updateSelected();
	end
end

function Lua_GiftSelectionWindow:onBtnCancelClick(go)
	self:hide();
end

function Lua_GiftSelectionWindow:onBtnSureClick(go)
	local data = self.showData.data;
		if self.selectedList:getSize() < data.option_amount then
			OperateAlert.show(LanUtil.formateStr(309034, tostring(data.option_amount)));
		return;
	end

	-- local haveCount = DataCenter.packData:getItemCountById(data.id);
	-- if haveCount > 1 then
	-- 	Lua_WindowUtil.openWin("Lua_ItemDetailsWindow", Lua_WinParam.ACTION_OPEN, { data = data, actVal = 1, selectedList = self.selectedList});
	-- else
	-- 	Lua_ProxyManager.getProxy("Lua_PackProxy"):sUseItem(data.pack_type, data.unique_id, 1, self.selectedList);
	-- end
	Lua_WindowUtil.openWin("Lua_ItemDetailsWindow", Lua_WinParam.ACTION_OPEN, { data = data, actVal = 1, selectedList = self.selectedList});
	self:hide();
end




















Lua_GiftSelectionItem = class("Lua_GiftSelectionItem", Lua_ListCell);
function Lua_GiftSelectionItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemIcon = Lua_ItemIcon.new(self.content);
	self.itemIcon:setScale(0.8, 0.8, 1);
	self.itemIcon:setLocation(0, 15, 0);

	self.nameText = UICreate.createLabel(self.content, nil, 0, -53, 100, 31, 24);
	self.nameText.pivotValue = 4;
	self.nameText.alignmentValue = 4;
	self.nameText.horizontalOverflowValue = 1;
	self.nameText.verticalOverflowValue = 0;
	-- self.nameText.bBestFit = true;
	self.nameText.colorStr = Lua_ColorDefine.transColor("856545");
end

function Lua_GiftSelectionItem:dispose()
	if self.itemIcon ~= nil then
		self.itemIcon:dispose();
		self.itemIcon = nil;
	end
	if self.scrollText then
		self.scrollText:dispose();
		self.scrollText = nil;
	end
	self.nameText = nil;
	self.customParam = nil;
	self.data = nil;
	self:superCall("dispose");
end

function Lua_GiftSelectionItem:setCustomParam(customParam)
	self.customParam = customParam;
end

function Lua_GiftSelectionItem:setData(data)
	self.data = data;
	self.itemIcon:setData(data.tvo);
	self.nameText.text = data.tvo.name;
	self.nameText:resetSize();
	if self.nameText.width > 100 then
		self.nameText:setEnable(false);
		if self.scrollText == nil then
			self.scrollText = Lua_ScrollText.new(self.content, Lua_AxisDefine.Horizontal, 100, 24);
			self.scrollText:setLocation(0, -53, 0);
			self.scrollText:setTextStyle(100, 24, Lua_MyUISettings.defaultFontName, 24, "856545", 0);
	    end
		self.scrollText:setEnable(true);
		self.scrollText:setShowTxt(data.tvo.name);
	else
		self.nameText:setEnable(true);
		if self.scrollText then
			self.scrollText:setEnable(false);
		end
	end
	self:updateSelected();
end

function Lua_GiftSelectionItem:updateSelected()
	if self.data == nil or self.customParam == nil or self.customParam:indexOf(self.data.optionId) == -1 then
		self.itemIcon:setDrawMask(false);
	else
		self.itemIcon:setDrawMask(true);
	end
end

function Lua_GiftSelectionItem:onPressClick()
	if self.data == nil then
		return;
	end
	Lua_MsgUtil.callFunc("GIFT_ITEM_SELECT", self.data.optionId);
end