Lua_HeroItemDetailsWindow = class("Lua_HeroItemDetailsWindow", Lua_Window)
function Lua_HeroItemDetailsWindow:ctor()
	self:superCall("ctor")

	self.layer = Lua_MainWinDefine.TIPS_WINDOW_LAYER;
	self.w = 396
	self.windowName = "Lua_HeroItemDetailsWindow"
	self.skinName = "HeroItemDetailsWindow_skin"
	self.showBlackMask = true
	self.isClickClose = true
end

function Lua_HeroItemDetailsWindow:buildShowItem()
	self:superCall("buildShowItem")
	self.itemIcon = Lua_ItemIcon.new(self.showObject)
	self.itemIcon:setLocation(-121.5, -54.5, 0)
	self.itemIcon:setScale(0.8, 0.8, 0.8)
end

function Lua_HeroItemDetailsWindow:dispose()
	if self.itemIcon then
		self.itemIcon:dispose()
		self.itemIcon = nil
	end
	if self.btnArr ~= nil then
		self.btnArr:dispose()
		self.btnArr:clear()
		self.btnArr = nil
	end
	self.data = nil
	self:superCall("dispose")
end

function Lua_HeroItemDetailsWindow:showWin(param)
	self:superCall("showWin", param)
	self.data = param.data
	self.isShowBtns = param.isShowBtns
	self:updateShowInfo()
end

function Lua_HeroItemDetailsWindow:updateShowInfo()
	self.winBg:setAltas("common_altas_2", "xui_common_itembg_1"..(self.data.color + 2))

	self.itemIcon:setData(self.data)
	self.itemIcon:showNum(0)
	self.nameText.text = self.data.name

	local heroConfig = Lua_HeroConfigData.getConfig(self.data.hero_id)
	self.titleText.text = heroConfig.title

	self.desText.text = self.data.des
	self.desText:resetSize()

	local minH = 122
	local spacingH = 14 -- 间距
	local addH = 0

	addH = addH + self.desText.height
	self.line:setLocation(0, self.desText.posY - self.desText.height - spacingH, 0)
	
	local list = self.data.buttonList
	if list == nil or #list <= 0 then
		self.isShowBtns = false
	end
	local btnStartY = self.line.posY - spacingH
	local btnH = self:showButtonList(list, btnStartY)
	if btnH > 0 then
		self.line:setEnable(true)
		addH = addH + self.line.height + spacingH -- 分割线与文本的间距
		addH = addH + btnH + spacingH -- 与分割线的间距
	else
		self.line:setEnable(false)
		addH = addH + spacingH
	end

	self.winBg:SetDimensions(self.w, minH + addH)
	LuaUtil.setObjPos(self.showObject, 0, self.winBg.height / 2, 0)
end

function Lua_HeroItemDetailsWindow:showButtonList(list, startY)
	if self.isShowBtns ~= true then
		return 0;
	end

	if self.btnArr == nil then
		self.btnArr = Array();
	end
	local arr = Array();
	local obj;
	if list ~= nil then
		for i = 1, #list do
			obj = list[i];
			if self.data.expired_tick ~= nil and self.data.expired_tick > 0 then
				if self.data.isExpired then
					if obj == 4 then
						arr:add(obj);
					end
				else
					if obj ~= 4 then
						arr:add(obj);
					end
				end
			else
				arr:add(obj);
			end
		end
	end

	local num = arr:getSize();
	local len = self.btnArr:getSize();
	local maxLen = num > len and num or len;

	local width = 141;
	local height = 54;
	local startX = 0;
	local spacingX = 0;
	local spacingY = 10;
	local count = 1;
	if num == 1 then
		startX = 0;
		count = 1;
	elseif num == 2 or num == 3 or num == 4 then
		startX = -102.5;
		spacingX = 205;
		count = 2;
	elseif num == 5 or num == 6 then
		width = 120;
		startX = -138;
		spacingX = 138;
		count = 3;
	end

	local btn;
	local posX;
	local posY;
	for i = 1, maxLen do
		btn = self.btnArr[i];
		if i > num then
			if btn ~= nil then
				btn:setEnable(false);
			end
		else
			if btn == nil then
				btn = UICreate.createButton(self.showObject, nil, 0, 0, width, height);
				self.btnArr:add(btn);
			else
				btn:setEnable(true);
			end
			btn.pivotValue = 1;
			btn:SetDimensions(width, height);
			btn:setStyle(14);
			btn.txt:setLocation(0, 0, 0);
			btn.txt.fontSize = 28;
			btn:setLangValue(309010 + arr[i]);
			btn.name = tostring(arr[i]);
			posX = startX + ((i - 1) % count) * spacingX;
			posY = startY + Mathf.Floor((i - 1) / count) * -(spacingY + height);
			-- if num == 5 and i == num then
			-- 	posX = posX + spacingX;
			-- end
			btn:setLocation(posX, posY, 0);
			btn:addClickFuntion(self, self.onButtonClick);
		end
	end

	if num < 3 then
		return height;
	end
	return height * 2 + spacingY;
end

function Lua_HeroItemDetailsWindow:onButtonClick(go)
	if Lua_WindowUtil.isWindowShowing("Lua_ObtainItemTipsWindow") then
		Lua_WindowUtil.openWin("Lua_ObtainItemTipsWindow", Lua_WinParam.ACTION_CLOSE);
	end
	DataCenter.packUtil:doActClick(self.data, tonumber(go.name))
end