-- 道具批量处理
Lua_ItemBatchPanel = class("Lua_ItemBatchPanel", Lua_ItemDetailsPanel);
function Lua_ItemBatchPanel:ctor(p)
	self:superCall("ctor", p, "ItemBatchPanel_skin", frameBuild);
end

function Lua_ItemBatchPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.minCount = 1;
	self.maxCount = 1;
	self.selectCount = 1;

	self.sliderBar = Lua_SliderProgressBar.new(self.showObject, "common_altas_1", "xui_common_tipsprogress_001_b", "xui_common_tipsprogress_001_f", "xui_common_tipsprogress_001_m", 200, 16);
	self.sliderBar:setLocation(-40, -60, 0);
	self.sliderBar:createLessPlus("common_altas_1", "xui_common_button_012", "xui_common_button_013", 10);
	self.sliderBar:createMinMax("common_altas_1", nil, "xui_common_button_014", 5);
	self.sliderBar:setTips(LanUtil.getValue(309037), LanUtil.getValue(309038));
	self.sliderBar:setCallBack(self, self.updateCount);

    self.btnFunc.txt:setLocation(0, 0, 0);
    self.btnFunc:addClickFuntion(self, self.onBtnFuncClick);
end

function Lua_ItemBatchPanel:dispose()
	if self.sliderBar ~= nil then
		self.sliderBar:dispose();
		self.sliderBar = nil;
	end
	if self.getArr ~= nil then
		self.getArr:dispose();
		self.getArr:clear();
		self.getArr = nil;
	end
	if self.getItem ~= nil then
		self.getItem:dispose();
		self.getItem = nil;
	end
	self.data = nil;
	self:superCall("dispose");
end

function Lua_ItemBatchPanel:setData(param)
	self.data = param.data;
	self.actVal = param.actVal;
	self.selectedList = param.selectedList;
	
	local baseH = 190;
	local spacingH = 21; -- 间距
	local maxH = 860 - baseH - spacingH * 2; -- 没有按钮的最大高度
	self.addH = 0;

	local desHeight = self:showDes(self.data, maxH);
	self.addH = self.addH + desHeight + spacingH; -- spacingH是文本与操作区的间距

	LuaUtil.setObjPos(self.showObject, 0, self.desText.posY - desHeight - spacingH, 0);
	self.addH = self.addH + 140; -- 操作区的高度

	self:updateShowInfo();

	self.addH = self.addH + spacingH * 2; -- 文本上方与最底下的间隔
	return self.addH;
end

function Lua_ItemBatchPanel:updateShowInfo()
	self.btnFunc:setLangValue(309010 + self.actVal);

	if self.actVal == 1 then -- 使用
		if self.data.eachAmount > 0 then
			self.maxCount = Mathf.Floor(self.data.count / self.data.eachAmount);
		else
			self.maxCount = self.data.count;
		end
		self.minCount = 1;
		self.selectCount = self.maxCount;

		if self.data.main_type == Lua_PackDefine.USE_TO_GET then
			if self.data.effect_param ~= nil and self.data.effect_param.profit_tick ~= nil and self.data.effect_param.money_type ~= nil then
				if self.getArr == nil then
					self.getArr = Array();
				end
				local list = self.data.effect_param.money_type;
				local startX = -80 * (#list - 1);
				local tvo;
				local item;
				self.getNum = self.data.effect_param.profit_tick;
				local profitCount;
				for i = 1, #list do
					tvo = Lua_ToolVo.createToolVo(list[i]);
					item = self.getArr[i];
					if item == nil then
						item = Lua_ItemBatchConsumeItem.new(self.showObject);
						self.getArr:add(item);
					end
					item:setLocation(startX + (i - 1) * 160, -107, 0);
					profitCount = DataCenter.hookData:getProfitCount(tvo.id);
					item:setData(tvo, self.getNum * profitCount * self.maxCount);
				end
				self.btnFunc:setLocation(0, -171, 0);
				self.addH = self.addH + 60;
			end
		end
	elseif self.actVal == 2 then -- 合成
		if self.data.compound == nil then
			self.minCount = 0;
			self.maxCount = 0;
			self.selectCount = 0;
		else
			self.maxCount = Mathf.Floor(self.data.count / self.data.compound[2]);
			self.minCount = 1;
			self.selectCount = self.maxCount;

			if not self.data.isHeroChip and not self.data.main_type == Lua_PackDefine.OTHER then
				local tvo = Lua_ToolVo.createToolVo(self.data.compound[1]);
				self:createGetInfo(tvo, self.maxCount);
			end
		end
	elseif self.actVal == 3 then -- 分解
		if self.data.decompose == nil then
			self.minCount = 0;
			self.maxCount = 0;
			self.selectCount = 0;
		else
			self.minCount = 1;
			self.maxCount = self.data.count;
			self.selectCount = self.maxCount;

			if self.getArr == nil then
				self.getArr = Array();
			end
			local list = self.data.decompose;
			local startX = -80 * (#list - 1);
			local tvo;
			local item;
			for i = 1, #list do
				tvo = Lua_ToolVo.createToolVo(list[i][1], list[i][2]);
				item = self.getArr[i];
				if item == nil then
					item = Lua_ItemBatchConsumeItem.new(self.showObject);
					self.getArr:add(item);
				end
				item:setLocation(startX + (i - 1) * 160, -107, 0);
				item:setData(tvo, tvo.count * self.maxCount);
			end
			self.btnFunc:setLocation(0, -171, 0);
			self.addH = self.addH + 60;
		end
	elseif self.actVal == 4 then -- 出售
		local tvo = Lua_ToolVo.createToolVo(self.data.money_id);
		self:createGetInfo(tvo, self.data.count * self.data.sys_price);

		self.minCount = 1;
		self.maxCount = self.data.count;
		self.selectCount = self.maxCount;
	end

	self.haveText.text = LanUtil.formateStr(309036, tostring(self.selectCount), tostring(self.maxCount));
	self.sliderBar:setValue(self.selectCount, self.minCount, self.maxCount);
end

function Lua_ItemBatchPanel:createGetInfo(data, count)
	if self.getItem == nil then
		self.getItem = Lua_ItemBatchConsumeItem.new(self.showObject);
		self.getItem:setLocation(0, -107, 0);
	end
	self.getItem:setData(data, count);
	self.btnFunc:setLocation(0, -171, 0);
	self.addH = self.addH + 60;
end

function Lua_ItemBatchPanel:updateCount(count)
	self.selectCount = count;
	if self.actVal == 1 then
		if self.data.main_type == Lua_PackDefine.USE_TO_GET and self.getArr ~= nil then
			local item;
			local profitCount;
			for i = 1, self.getArr:getSize() do
				item = self.getArr[i];
				profitCount = DataCenter.hookData:getProfitCount(item.data.id);
				item:setData(item.data, self.getNum * profitCount * count);
			end
		end
	elseif self.actVal == 2 then
		if self.getItem ~= nil then
			self.getItem:setData(self.getItem.data, count);
		end
	elseif self.actVal == 3 then
		if self.getArr ~= nil then
			local item;
			for i = 1, self.getArr:getSize() do
				item = self.getArr[i];
				item:setData(item.data, item.data.count * count);
			end
		end
	elseif self.actVal == 4 then
		if self.getItem ~= nil then
			self.getItem:setData(self.getItem.data, count * self.data.sys_price);
		end
	end
	self.haveText.text = LanUtil.formateStr(309036, tostring(count), tostring(self.maxCount));
end

function Lua_ItemBatchPanel:onBtnFuncClick()
	if self.data == nil then
		self:hide();
		return;
	end

	if self.maxCount <= 0 then
		DataCenter.packUtil:openPathWindow(self.data.id, false);
		self:hide();
		return;
	end

	if self.actVal == 1 then
	    -- 自选礼包
		local use_argv = nil;
		if self.data.sub_type == Lua_PackDefine.GIFT_BAG_SELECT or self.data.sub_type == Lua_PackDefine.GIFT_BAG_SELECT_HERO then
			use_argv = self.selectedList;
		end
		Lua_ProxyManager.getProxy("Lua_PackProxy"):sUseItem(self.data.pack_type, self.data.unique_id, self.selectCount, use_argv);
	elseif self.actVal == 2 then
	    -- 英雄碎片
		if self.data.isHeroChip then
			if not DataCenter.heroData:isBagEnough(self.selectCount) then
				OperateAlert.showLangValue(140321);
				return;
			end
		end
		Lua_ProxyManager.getProxy("Lua_PackProxy"):sSyntheticItem(self.data.id, self.selectCount);
	elseif self.actVal == 3 then
		Lua_ProxyManager.getProxy("Lua_PackProxy"):sDecomposeItem(self.data.id, self.selectCount);
	elseif self.actVal == 4 then
		local tab = {};
		tab[self.data.unique_id] = { pack_type = self.data.pack_type, unique_id = self.data.unique_id, count = self.selectCount };
		Lua_ProxyManager.getProxy("Lua_PackProxy"):sSellItem(tab);
	end
	Lua_WindowUtil.openWin("Lua_ItemDetailsWindow", Lua_WinParam.ACTION_CLOSE);
end





















Lua_ItemBatchConsumeItem = class("Lua_ItemBatchConsumeItem", Lua_DisplayObject)
function Lua_ItemBatchConsumeItem:ctor(p)
	self:superCall("ctor", p, nil, frameBuild)
end

function Lua_ItemBatchConsumeItem:buildShowItem()
	self:superCall("buildShowItem")
	self.bg = UICreate.createUIAtlasImage(self.content, "common_altas_1", "xui_common_edit_001", 0, 0, 110, 38)
	self.icon = UICreate.createUIAtlasImage(self.content, nil, nil, -35, 0, 0, 0)
	self.countText = UICreate.createLabel(self.content, nil, 32.5, 0, 100, 31, 21)
	self.countText.alignmentValue = 3
	self.countText.pivotValue = 4
	self.countText.horizontalOverflowValue = 1
end

function Lua_ItemBatchConsumeItem:dispose()
	self.data = nil
	self:superCall("dispose")
end

function Lua_ItemBatchConsumeItem:setData(data, count)
	self.data = data
	self.icon:setAltas(data.iconAtlas, data.iconSprite)
	self.icon:SetDimensions(data.iconWidth, data.iconHeight)
	self.countText.text = numberTrans(count)
end