checkRequire("Lua_ItemDetailsPanel");
checkRequire("Lua_ItemBatchPanel");
Lua_ItemDetailsWindow = class("Lua_ItemDetailsWindow", Lua_Window);
function Lua_ItemDetailsWindow:ctor()
    self:superCall("ctor");

    self.layer = Lua_MainWinDefine.TIPS_WINDOW_LAYER;
    self.w = 436;
    self.showBlackMask = true;
    self.isClickClose = true;
    self.windowName = "Lua_ItemDetailsWindow";
    self.skinName = "ItemDetailWindow_skin";
end

function Lua_ItemDetailsWindow:buildShowItem()
    self:superCall("buildShowItem");
    self.itemIcon = Lua_ItemIcon.new(self.showObject);
    self.itemIcon:setLocation(-120, -92.5, 0);

    self.checkSource:addClickFuntion(self, self.onCheckSource);
end

function Lua_ItemDetailsWindow:dispose()
    if self.scrollText ~= nil then
        self.scrollText:dispose();
        self.scrollText = nil;
    end
    if self.itemIcon ~= nil then
        self.itemIcon:dispose();
        self.itemIcon = nil;
    end
    if self.curPanel ~= nil then
        self.curPanel:dispose();
        self.curPanel = nil;
    end
    self:superCall("dispose");
    Lua_MsgUtil.callFunc("ITEM_DETAILS_CLOSE")
end

function Lua_ItemDetailsWindow:showWin(param)
    self:superCall("showWin", param);
    self:showInfo(param.data);
    self:updateShowInfo();
end

function Lua_ItemDetailsWindow:updateShowInfo()
    if self.curPanel ~= nil then
        self.curPanel:dispose();
        self.curPanel = nil;
    end

    if self.showData.actVal == nil then
        self.curPanel = Lua_ItemDetailsPanel.new(self.showObject); -- 道具详情
    else
        self.curPanel = Lua_ItemBatchPanel.new(self.showObject); -- 道具批量处理
    end

    local baseH = 190; -- 基础高度
    local addH = self.curPanel:setData(self.showData);
    addH = addH == nil and 0 or addH
    self.winBg:SetDimensions(self.w, baseH + addH);
    LuaUtil.setObjPos(self.showObject, 0, self.winBg.height / 2 + 39, 0);
end

function Lua_ItemDetailsWindow:showInfo(data)
    self.itemIcon:setData(data);
    self.itemIcon:showNum(0);
    self.itemIcon:setDoubleIcon(nil);
    -- self.nameText.text = data.colorName;
    self:setTxtDisplay(data.colorName);

    self.useText.text = data.effect_des;

    if strIsNullOrEmpty(data.effect_des) then
        self.haveText.alignmentValue = 3
        self.haveText:setLocation(-18.5, -94, 0)
    else
        self.haveText.alignmentValue = 5
        self.haveText:setLocation(175.5, -94, 0)
    end

    local count = DataCenter.packData:getItemCountById(data.id);
    self.haveText:setEnable(true);
    self.haveText.text = LanUtil.formateStr(309010, numberTrans(count));

    self.checkSource:setEnable(data.showPath == 1 and self.showData.isInPack == true);
end

function Lua_ItemDetailsWindow:onCheckSource(go)
    DataCenter.packUtil:openPathWindow(self.showData.data, false);
    self:hide()
end

function Lua_ItemDetailsWindow:setTxtDisplay(str)
    self.nameText.text = str;
    self.nameText:resetSize();
    if self.nameText.width > 242 then
        self.nameText:setEnable(false);
        if self.scrollText == nil then
            self.scrollText = Lua_ScrollText.new(self.showObject, Lua_AxisDefine.Horizontal, 242, 40);
            self.scrollText:setLocation(75, -54, 0);
            self.scrollText:setTextStyle(242, 40, Lua_MyUISettings.huakangFontName, 30, "FFFFFF", 0, "555555");
        end
        self.scrollText:setEnable(true);
        self.scrollText:setShowTxt(str);
    else
        self.nameText:setEnable(true);
        if self.scrollText then
            self.scrollText:setEnable(false);
        end
    end
end