-- 道具获得提示
Lua_ObtainItemTipsWindow = class("Lua_ObtainItemTipsWindow", Lua_Window);
function Lua_ObtainItemTipsWindow:ctor()
    self:superCall("ctor");

    self.layer = Lua_MainWinDefine.TIPS_WINDOW_LAYER;
    self.w = 720;
    self.h = 372;
    self.windowName = "Lua_ObtainItemTipsWindow";
    -- self.skinName = "ObtainItemTipsWindow_skin";
    self.showBlackMask = true;
    self.showWinBg = true;
    self.winBgAtlas = "common_altas_1";
    self.winBgSprite = "default";
    self.winBgPosY = 80;
    self.openSound = "obtain_item_01";
    self:addPreLoadRes("/images/common/xui_common_window_004.png", Lua_LoadFileType.IMG);
    self:addPreLoadRes("/effects/uiEffects/ui_ty_reward01", Lua_LoadFileType.UNITY3D);
    self.showParams = Array();
end

function Lua_ObtainItemTipsWindow:buildShowItem()
    self:superCall("buildShowItem");
    self.showHeroArr = Array();

    self.bgEff = UICreate.createUIEffect(self.content, nil, nil, 0, 80);
    self.bgEff.siblingIndex = 1;
    self.bgEff:addLuaLoadCompleteFun(self, self.onBgEffLoaded);
    self.bgEff:setUrl("/effects/uiEffects/ui_ty_reward01", "ui_ty_reward01");

    self.titleEff = UICreate.createUIEffect(self.content, "/effects/uiEffects/ui_getreward", "ui_getreward", -221, 323);
    self.rewardEff = UICreate.createUIEffect(self.content, "/effects/uiEffects/ui_ty_reward02", "ui_ty_reward02", 0, 80);
end

function Lua_ObtainItemTipsWindow:showWin(param)
    self:superCall("showWin", param);
    if param == nil and (param.data == nil or param.data:getSize() <= 0) then
        if self:checkShowOrHide() == false then
            self:hide();
        end
        return;
    end
    
    self.showParams:add(param);
    if self.bTimer == true then
        return;
    end
    self:showNextInfo();
end

function Lua_ObtainItemTipsWindow:onBgEffLoaded()
    self.bgEff:setAct(1);
end

function Lua_ObtainItemTipsWindow:checkShowOrHide()
    if self.bTimer == true then
        return true;
    end

    if self.showParams == nil or self.showParams:getSize() <= 0 then
        return false;
    end
    return true;
end

function Lua_ObtainItemTipsWindow:showNextInfo()
    if self.showParams == nil then
        self:superCall("onMaskClick", go);
        return;
    end

    while (self.showParams:getSize() > 0) do
        self.param = self.showParams:shift();
        if self.param ~= nil then
            break;
        end
    end

    if self.param == nil then
        self:superCall("onMaskClick", go);
        return;
    end

    local data = self.param.data;
    if data == nil then
        data = self.param;
    end
    local len = data:getSize();
    for i = 1, len do
        self:addShowHero(data[i])
    end
    local width;
    local height;
    local interval = 10;
    if len > 10 then
        width = 664;
        height = 372
    elseif len > 5 then
        width = 664;
        height = 155 * Mathf.Floor(len / 5) + 124 / 2;
    else
        width = 124 * len + interval * (len - 1)+4;
        height = 160;
    end

    self.winBg:SetDimensions(720, height);
    if self.itemList == nil then
        self.itemList = Lua_DragList.new(self.content, width, height, Lua_AxisDefine.Vertical);
        if self.rewardEff then
            self.itemList:setSiblingIndex(self.rewardEff.siblingIndex - 1);
        end
        self.itemList:setLocation(0, 80, 0);
        self.itemList:setListCell(Lua_ObtainItemTipsItem, 124, 160, 5);
        self.itemList:setCellSpacing(interval, 0);
    else
        self.itemList:setContentRect(width, height, false);
    end
    self.itemList.canDrag = len > 5;
    self.itemList:setArrayData(data);

    LuaUtil.setObjScale(self.itemList.mainContent, 0, 0, 0);
    TweenUtil.getInstance():stop(self.itemList.mainContent);
    TweenUtil.getInstance():addTweenTargetScale(self.itemList.mainContent, 0.3, 0.1, 1, 1, 1);
    Lua_CommonUtil.delayCall(0.4, self, self.onTweenCompleted)
end

function Lua_ObtainItemTipsWindow:addShowHero(vo)
    if vo.main_type == Lua_PackDefine.HERO and vo.isNew == 1 and vo.hero_id > 0 then
        local list = Lua_CommonUtil.getCommonConfig("new_hero_show_limit", 3);
        if list and vo.quality >= list[1] and vo.quality <= list[2] and self.showHeroArr:indexOf(vo.hero_id) == -1 then
            self.showHeroArr:add(vo.hero_id);
        end
    end
end

function Lua_ObtainItemTipsWindow:onTweenCompleted()
    if self.rewardEff then
        self.rewardEff:dispose();
        self.rewardEff = nil;
    end
    self.isClickClose = true;
    self:createCloseTips(0, -259.5, 0);
    DataCenter.packUtil:openHeroWindow(self.showHeroArr);
end

function Lua_ObtainItemTipsWindow:onMaskClick(go)
    if self.isClickClose == true then
        if self.param.data ~= nil then
            self.param.data = nil;
        end
        if self.param.owner ~= nil then
            if self.param.cancelFun ~= nil then
                self.param.cancelFun(self.param.owner, self.param);
            end
            self.param.owner = nil;
            self.param.cancelFun = nil;
            self.param = nil;
        end
        self.param = nil;

        self:showNextInfo();
    end
end

function Lua_ObtainItemTipsWindow:dispose()
    if self.itemList then
        TweenUtil.getInstance():stop(self.itemList.mainContent);
    end
    Lua_CommonUtil.removeTimer(self, self.onTweenCompleted);
    if self.bgEff then
        self.bgEff:dispose();
        self.bgEff = nil;
    end
    if self.titleEff then
        self.titleEff:dispose();
        self.titleEff = nil;
    end
    if self.rewardEff then
        self.rewardEff:dispose();
        self.rewardEff = nil;
    end
    if self.itemList ~= nil then
        self.itemList:dispose();
        self.itemList = nil;
    end
    if self.param ~= nil then
        if self.param.owner ~= nil then
            self.param.owner = nil;
            self.param.cancelFun = nil;
        end
        if self.param.data ~= nil then
            self.param.data = nil;
        end
        self.param = nil;
    end
    if self.showParams ~= nil then
        while (self.showParams:getSize() > 0) do
            self.param = self.showParams:shift();
            if self.param ~= nil then
                if self.param.owner ~= nil then
                    self.param.owner = nil;
                    self.param.cancelFun = nil;
                end
                if self.param.data ~= nil then
                    self.param.data = nil;
                end
                self.param = nil;
            end
        end
        self.showParams:dispose();
        self.showParams:clear();
        self.showParams = nil;
    end
    if self.showHeroArr then
        self.showHeroArr:clear();
        self.showHeroArr = nil;
    end
    self:superCall("dispose");
end




















Lua_ObtainItemTipsItem = class("Lua_ObtainItemTipsItem", Lua_ItemIconCell)
function Lua_ObtainItemTipsItem:ctor(p)
    self:superCall("ctor", p)
end

function Lua_ObtainItemTipsItem:buildShowItem()
    self:superCall("buildShowItem")
    self.itemIcon:setLocation(0, 15, 0)

    self.nameText = UICreate.createLabel(self.content, nil, 0, -62.5, 124, 31, 20)
    self.nameText.alignmentValue = 4
    self.nameText.pivotValue = 4
    self.nameText.horizontalOverflowValue = 1;
    self.nameText.verticalOverflowValue = 0;
    -- self.nameText.bBestFit = true;
    self.nameText.colorStr = Lua_ColorDefine.transColor("FFFFFF")
    self.nameText.effectStyle = 2
    self.nameText.effectColorStr = Lua_ColorDefine.transColor("555555")
    self.nameText:setEffectDistance(2, 2)
end

function Lua_ObtainItemTipsItem:dispose()
    if self.scrollText then
        self.scrollText:dispose();
        self.scrollText = nil;
    end
    self:superCall("dispose");
end

function Lua_ObtainItemTipsItem:setData(data)
    self:superCall("setData", data)
    self.nameText.text = self.data.name
    self.nameText:resetSize();
    if self.nameText.width > 124 then
        self.nameText:setEnable(false);
        if self.scrollText == nil then
            self.scrollText = Lua_ScrollText.new(self.content, Lua_AxisDefine.Horizontal, 124, 24);
            self.scrollText:setLocation(0, -62.5, 0);
            self.scrollText:setTextStyle(124, 24, Lua_MyUISettings.defaultFontName, 20, "FFFFFF", 2, "555555");
        end
        self.scrollText:setEnable(true);
        self.scrollText:setShowTxt(self.data.name);
    else
        self.nameText:setEnable(true);
        if self.scrollText then
            self.scrollText:setEnable(false);
        end
    end
end