-- 道具获取途径
Lua_ObtainPathWindow = class("Lua_ObtainPathWindow", Lua_Window);
function Lua_ObtainPathWindow:ctor()
    self:superCall("ctor");

    self.layer = Lua_MainWinDefine.TIPS_WINDOW_LAYER;
    self.windowName = "Lua_ObtainPathWindow";
    self.skinName = "ObtainPathWindow_skin";
    self.showBlackMask = true;
    self.isClickClose = true;
end

function Lua_ObtainPathWindow:buildShowItem()
    self:superCall("buildShowItem");

    self.itemIcon = Lua_ItemIcon.new(self.content);
    self.itemIcon:setLocation(-217, 236.5, 0);
    self.itemIcon:setCanClick(false);

    self.textArea = Lua_TextArea.new(self.content, 435, 80);
    self.textArea:setLocation(103, 185, 0);

    self.itemList = Lua_DragList.new(self.content, 628, 570, Lua_AxisDefine.Vertical);
    self.itemList:setLocation(1, -173.5, 0);
    self.itemList.tweenId = 2002;
    self.itemList:setListCell(Lua_ObtainPathItem, 628, 132, 1);
    self.itemList:setCellSpacing(0, 5)
end

function Lua_ObtainPathWindow:dispose()
    if self.itemIcon ~= nil then
        self.itemIcon:dispose();
        self.itemIcon = nil;
    end
    if self.textArea ~= nil then
        self.textArea:dispose();
        self.textArea = nil;
    end
    if self.itemList ~= nil then
        self.itemList:dispose();
        self.itemList = nil;
    end
    self:superCall("dispose");
end

function Lua_ObtainPathWindow:showWin(param)
    self:superCall("showWin", param);
    
    self.itemIcon:setData(param);
    self.itemIcon:showNum(0);
    self.nameText.text = param.name;
    
    local count = DataCenter.packData:getItemCountById(param.id);
    self.haveCount.text = LanUtil.formateStr(309009, numberTrans(count));

    self.textArea:setText(param.des, 25, 1, 0, "726763");

    self.itemList:setArrayData(param.obtain_path);
end




















Lua_ObtainPathItem = class("Lua_ObtainPathItem", Lua_ListCell);
function Lua_ObtainPathItem:ctor(p)
    self:superCall("ctor", p, "ObtainPathItem_skin");
end

function Lua_ObtainPathItem:buildShowItem()
    self:superCall("buildShowItem");
    self.btnGoto:addClickFuntion(self, self.onBtnGotoClick)
end

function Lua_ObtainPathItem:dispose(go)
    self.data = nil;
    self:superCall("dispose");
end

function Lua_ObtainPathItem:setData(data)
    if data == nil then
        return;
    end
    self.data = DataCenter.funcPathUtil:getFuncPathVo(data[1]);

    self.recoIcon:setEnable(data[2] ~= nil and data[2] > 0);
    if self.data == nil then
        self.nameText:setEnable(false);
        self.btnGoto:setEnable(false);
        self.promptText:setEnable(false);
    else
        self.nameText:setEnable(true);
        self.nameText.text = self.data.name;
        if strIsNullOrEmpty(self.data.btn_name) then
            self.btnGoto:setEnable(false);
        else
            self.btnGoto.label = self.data.btn_name;
            if self.data.openState then
                self.btnGoto:setEnable(not self.data.isShowing);
                self.promptText:setEnable(false);
            else
                self.btnGoto:setEnable(false);
                self.promptText:setEnable(true);
                self.promptText.text = self.data.promptStr;
            end
        end
    end
end

function Lua_ObtainPathItem:onBtnGotoClick(go)
    if self.data == nil then
        return;
    end
    if DataCenter.funcPathUtil:gotoFunction(self.data.id, true) then
        Lua_WindowUtil.openWin("Lua_ObtainPathWindow", Lua_WinParam.ACTION_CLOSE)
    end
end