checkRequire("Lua_PackPanel");
Lua_PackChipPanel = class("Lua_PackChipPanel", Lua_PackPanel);
function Lua_PackChipPanel:ctor(p)
	self:superCall("ctor", p);
end

function Lua_PackChipPanel:buildShowItem()
	self:superCall("buildShowItem");

    self.itemList:setListCell(Lua_PackChipItem, 140, 175, 4);
    self.itemList:setCellSpacing(20, 0);
end

function Lua_PackChipPanel:initEvent()
	self:addLuaEvent("ADD_PACK_ITEMS", self, self.addItem);
	self:addLuaEvent("REMOVE_PACK_ITEMS", self, self.removeItem);
end

function Lua_PackChipPanel:setData(data)
	self.data = data;
	self:updateShowInfo();

	self.itemArr, self.itemDic = DataCenter.packData:getPackArrByPackType(data.package);
	self:updateListInfo(self.itemArr);
end




















Lua_PackChipItem = class("Lua_PackChipItem", Lua_ListCell);
function Lua_PackChipItem:ctor(p)
	self:superCall("ctor", p, "PackChipItem_skin");
end

function Lua_PackChipItem:buildShowItem()
	self:superCall("buildShowItem");
	
	self.itemIcon = Lua_ItemIcon.new(self.content);
	self.itemIcon:setSiblingIndex(1)
	self.itemIcon:setLocation(0, 10, 0);
end

function Lua_PackChipItem:dispose()
	if self.itemIcon ~= nil then
		self.itemIcon:dispose();
		self.itemIcon = nil;
	end
	self.data = nil;
	self:superCall("dispose");
end

function Lua_PackChipItem:setData(data)
	self.data = data;
	if type(data) == "number" then
		if data == 0 then
			self.data = nil;
		else
			self.data = DataCenter.packData:getItemVoByUnId(data);
		end
	end

	self.itemIcon:setData(self.data);
	self.itemIcon:showRedPoint(self.data.canCompound or self.data.isShowGiftBagUseRed);
	self.itemIcon:showNum(0);
	self.itemIcon:setDoubleIcon(nil);
	if self.data == nil then
		self.bar:setEnable(false);
		self.countText:setEnable(false);
		self:showUseLogo(false);
	else
		if self.data.compound then -- 合成
			local maxValue = self.data.compound[2];
			local value = self.data.count;
			self.bar:setEnable(true);
			self.bar:setMaxValue(maxValue);
			self.bar:setValue(value);
			self.countText:setEnable(true);
			self.countText.text = LanUtil.formateStr(10044, tostring(value), tostring(maxValue));
		elseif self.data.eachAmount > 0 then -- 自选礼包碎片
			self.bar:setEnable(true);
			self.bar:setMaxValue(self.data.eachAmount);
			self.bar:setValue(self.data.count);
			self.countText:setEnable(true);
			self.countText.text = LanUtil.formateStr(10044, tostring(self.data.count), tostring(self.data.eachAmount));
		else
			self.bar:setEnable(false);
			self.countText:setEnable(true);
			self.countText.text = self.data.count;
		end
		self:showUseLogo(self.data.use_logo == 1);
	end
end

function Lua_PackChipItem:showUseLogo(value)
	if value then
		if self.useIcon == nil then
			self.useIcon = UICreate.createUIAtlasImage(self.content, "common_altas_1", "xui_common_label_11", 48.5, 71, 0, 0);
		end
		self.useIcon:setEnable(true);
	else
		if self.useIcon then
			self.useIcon:setEnable(false);
		end
	end
end

function Lua_PackChipItem:onPressClick()
	if self.data == nil or self.data.id == nil then
		return;
	end
	DataCenter.packUtil:showItemInfo(self.data, true, true);
end

function Lua_PackChipItem:onMouseDownHandle()
	self.itemIcon:setScale(0.95, 0.95, 0.95);
end

function Lua_PackChipItem:onMouseUpHandle()
	self.itemIcon:setScale(1, 1, 1);
end