Lua_PackFilterListWindow = class("Lua_PackFilterListWindow", Lua_Window);
function Lua_PackFilterListWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_PackFilterListWindow"
	self.showBlackMask = true
	self.blackAlpha = 0.1
	self.showWinBg = true
	self.winBgAtlas = "common_altas_1"
	self.winBgSprite = "xui_common_widget_014"
	self.winBgPosX = -152
	self.winBgPosY = -475
	self.isClickClose = true
end

function Lua_PackFilterListWindow:buildShowItem()
	self:superCall("buildShowItem")
	self.winBg:SetDimensions(178, 140)

	self:addLuaEvent("PACK_FILTER_SINGLE", self, self.onFileterSelected)

	self.selectList = Lua_DragList.new(self.content, 172, 130, Lua_AxisDefine.Vertical)
	self.selectList:setLocation(self.winBgPosX, self.winBgPosY, 0)
	self.selectList.tweenId = 2004
	self.selectList:setListCell(Lua_PackFilterListItem, 172, 50, 1)
	self.selectList:setCellSpacing(0, 3)
end

function Lua_PackFilterListWindow:dispose()
	Lua_MsgUtil.callFunc("PACK_FILTER_LIST_CLOSE")
	if self.selectList then
		self.selectList:dispose()
		self.selectList = nil
	end
	self:superCall("dispose")
end

function Lua_PackFilterListWindow:showWin(param)
	self:superCall("showWin", param)

	self.filterDic = param.filterDic == nil and {} or deep_copy(param.filterDic)
	local filter = DataCenter.packData:getFilterByPackType(param.packType)
	self.selectList:setArrayData(filter["colorStar"])
end

function Lua_PackFilterListWindow:onFileterSelected(data)
	if self.filterDic["colorStar"] == nil then
		self.filterDic["colorStar"] = {}
	end
	self.filterDic["colorStar"] = data
	Lua_MsgUtil.callFunc("PACK_FILTER", self.filterDic)
	self:hide()
end




















Lua_PackFilterListItem = class("Lua_PackFilterListItem", Lua_ListCell)
function Lua_PackFilterListItem:ctor(p)
	self:superCall("ctor", p)
end

function Lua_PackFilterListItem:buildShowItem()
	self:superCall("buildShowItem")
	self.bg = UICreate.createUIAtlasImage(self.content, "common_altas_1", "xui_common_edit_002", 0, 0, 172, 50)

	self.nameText = UICreate.createLabel(self.content, nil, 0, 0, 100, 31, 24)
	self.nameText.pivotValue = 4
	self.nameText.alignmentValue = 4
	self.nameText.horizontalOverflowValue = 1
	self.nameText.colorStr = Lua_ColorDefine.transColor("7A6A5E")
end

function Lua_PackFilterListItem:dispose()
	self.data = nil
	self:superCall("dispose")
end

function Lua_PackFilterListItem:setData(data)
	self.data = data
	self.nameText.text = DataCenter.packData:getFilterName(data)
end

function Lua_PackFilterListItem:onPressClick()
	Lua_MsgUtil.callFunc("PACK_FILTER_SINGLE", self.data)
end