Lua_PackFilterWindow = class("Lua_PackFilterWindow", Lua_Window);
function Lua_PackFilterWindow:ctor()
    self:superCall("ctor");

    self.windowName = "Lua_PackFilterWindow";
    self.skinName = "PackFilterWindow_skin";
    self.showBlackMask = true;
    self.isClickClose = true;
end

function Lua_PackFilterWindow:buildShowItem()
    self:superCall("buildShowItem");
    self.itemArr = Array();
    self:addLuaEvent("PACK_FILTER_SINGLE", self, self.onFileterSelected);

    self.btnSure:addClickFuntion(self, self.onBtnSureClick);
end

function Lua_PackFilterWindow:dispose()
    if self.itemArr ~= nil then
        self.itemArr:dispose();
        self.itemArr:clear();
        self.itemArr = nil;
    end
    self:superCall("dispose");
end

function Lua_PackFilterWindow:showWin(param)
    self:superCall("showWin", param);

    self.filterDic = param.filterDic == nil and {} or deep_copy(param.filterDic);
    local filter = DataCenter.packData:getFilterByPackType(param.packType);
    local len = table.length(filter);
    local posY = len == 1 and 53 or 105
    for key, list in pairs(filter) do
        self:createItem(key, list, posY);
        posY = posY - 105;
    end
end

function Lua_PackFilterWindow:createItem(key, list, posY)
    local item;
    local value;
    local selected;
    for i = 1, #list do
        value = list[i];
        item = Lua_PackFilterItem.new(self.content);
        item:setLocation(-253 + (i - 1) * 100, posY, 0);
        selected = self.filterDic[key] ~= nil and self.filterDic[key][value] == 1;
        item:setData(key, value, selected);
        self.itemArr:add(item);
    end
end

function Lua_PackFilterWindow:onFileterSelected(data)
    if data.bSelected then
        if self.filterDic[data.key] == nil then
            self.filterDic[data.key] = {};
        end
        self.filterDic[data.key][data.value] = 1;
    else
        if self.filterDic[data.key] ~= nil then
            self.filterDic[data.key][data.value] = nil;
            local index = 0;
            for k,v in pairs(self.filterDic[data.key]) do
                index = index + 1;
            end
            if index == 0 then -- 检查满足筛选时减少循环
                self.filterDic[data.key] = nil;
            end
        end
    end
end

function Lua_PackFilterWindow:onBtnSureClick(go)
    Lua_MsgUtil.callFunc("PACK_FILTER", self.filterDic);
    self:hide();
end




















Lua_PackFilterItem = class("Lua_PackFilterItem", Lua_DisplayObject);
function Lua_PackFilterItem:ctor(p)
    self:superCall("ctor", p);
end

function Lua_PackFilterItem:buildShowItem()
    self:superCall("buildShowItem");

    self.cbSelect = UICreate.createCheckBox(self.content, nil, 0, 0, 100, 31);
    self.cbSelect:setStyle(2);
    self.cbSelect:setDir(2);
    self.cbSelect:addBoxChange(self, self.onCheckBoxChange);
end

function Lua_PackFilterItem:dispose()
    self.cbSelect = nil;
    self:superCall("dispose");
end

function Lua_PackFilterItem:setData(key, value, selected)
    self.key = key;
    self.value = value;
    self.cbSelect.selected = selected;

    if key == "color" then
        self.cbSelect:setLangValue(309050 + value);
    elseif key == "camp" then
        self.cbSelect:setLangValue(309040 + value);
    elseif key == "star" then
        self.cbSelect.label = LanUtil.formateStr(309039, tostring(value));
    elseif key == "quality" then
        self.cbSelect.label = DataCenter.heroUtil:getHeroQualityName(value);
    end
end

function Lua_PackFilterItem:onCheckBoxChange(bSelected)
    Lua_MsgUtil.callFunc("PACK_FILTER_SINGLE", { key = self.key, value = self.value, bSelected = bSelected });
end