Lua_PackWindow = class("Lua_PackWindow", Lua_Window);
function Lua_PackWindow:ctor()
    self:superCall("ctor");

    self.windowName = "Lua_PackWindow";
    self.showBlackMask = true;
    self.showWinBg = true;
    self.winBgPath = "/images/common/xui_common_window_001.png";
    self.winBgPosY = 22.5;
    self.showTitle = true;
    self.titleText = LanUtil.getValue(309068);
    self.titleNamePosY = 485;
    self.showClose = true;
    self.btnCloseAtlas = "common_altas_1";
    self.btnCloseSprite = "xui_common_button_001_n";
    self.btnClosePosX = 306;
    self.btnClosePosY = 496;
    self.isClickClose = true;
    self:addPreLoadRes(self.winBgPath, Lua_LoadFileType.IMG);
end

function Lua_PackWindow:buildShowItem()
    self:superCall("buildShowItem");
    self.titleName.effectStyle = 2;
    self.titleName.effectColorStr = Lua_ColorDefine.transColor("F3E7D5");
    self.titleName:setEffectDistance(2, 2);

    self.panelDic = {};
    self.packArr = DataCenter.packData:getPackTagList();

    self.buttonList = Lua_ButtonList.new(self.content, Lua_AxisDefine.Horizontal);
    self.buttonList:setSiblingIndex(0)
    self.buttonList:setLocation(0, -570, 0);
    self.buttonList:setButtonStyle("common_altas_1", "xui_common_tab_002", "xui_common_tab_001", 133, 77);
    self.buttonList:setButtonText(0, 10, "7A6A5F", "8F5123", 30, 30, Lua_MyUISettings.huakangFontName);
    self.buttonList:setRedPoint(45, 15);
    self.buttonList:setButtonItem(135, 77);
    self.buttonList:setClickCallBack(self, self.onButtonClick);
    self.buttonList:setData(self.packArr);
end

function Lua_PackWindow:dispose()
    if self.panelDic ~= nil then
        for k,v in pairs(self.panelDic) do
            v:dispose();
        end
        self.panelDic = nil;
    end
    self.showPanel = nil;
    if self.buttonList ~= nil then
        self.buttonList:dispose();
        self.buttonList = nil;
    end
    self.packArr = nil;
    self:superCall("dispose");
end

function Lua_PackWindow:showWin(param)
    local packType;
    if type(param) == "table" then
        packType = param.main_id;
    elseif type(param) == "number" then
        packType = param;
    end

    local index;
    for i = 1, self.packArr:getSize() do
        if self.packArr[i].package == packType then
            index = i;
            break;
        end
    end
    index = index == nil and 1 or index;
    self.buttonList:setSelected(index)
end

function Lua_PackWindow:onButtonClick(index)
    local data = self.packArr[index]
    if data == nil or strIsNullOrEmpty(data.panel_name) then
        return
    end

    for k,v in pairs(self.panelDic) do
        v:setEnable(false)
    end
    if self.panelDic[data.panel_name] == nil then
        local showPanel = checkRequire(data.panel_name);
        self.panelDic[data.panel_name] = showPanel.new(self.content)
    end
    self.showPanel = self.panelDic[data.panel_name]
    self.showPanel:setEnable(true)
    self.showPanel:setData(data)
end

function Lua_PackWindow:onPackTypeSelect(data)
    if self.selectedType == data.package or strIsNullOrEmpty(data.panel_name) then
        return;
    end
    self.selectedType = data.package;

    for k,v in pairs(self.panelDic) do
        v:setEnable(false);
    end

    if self.panelDic[data.panel_name] == nil then
        local showPanel = checkRequire(data.panel_name);
        self.panelDic[data.panel_name] = showPanel.new(self.content);
    end

    self.showPanel = self.panelDic[data.panel_name];
    self.showPanel:setEnable(true);
    self.showPanel:setData(data);
end
